# **********************************************************************
# Copyright 2021 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
import json

from cli.commands.cli_command_provider import CliCommandProvider
from cli.commands.lcp_common.opsagent.client import get_opsagent_cli_output
from cli.commands.lcp_common.opsagent.client import load_response_output


class GetEdgeIdsEvtStats(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_opsagent_cli_output("get/edgeidsStats")
        if response is None:
            return "MSG_EDGEIDSEVT_STATS_FAILED"

        jobj = json.loads(response)
        return "OK\n\n%s" % json.dumps(jobj)


class ClearEdgeIdsEvtStats(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_opsagent_cli_output("clear/edgeidsStats")
        if response is None:
            return "MSG_EDGEIDSEVT_STATS_FAILED"

        return "OK\n\n%s" % json.dumps(response)

