# **********************************************************************
# Copyright 2018 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import json
import nsx_logging
from cli.commands.cli_command_provider import CliCommandProvider
from cli.commands.lcp_common.opsagent.client import get_opsagent_cli_output
from cli.commands.lcp_common.opsagent.client import load_response_output

#lg = nsx_logging.getLogger("cli.commands.host_esx.epct")


_PROTO_DESC = {
    "tcponly": "TCP protocol only",
    "all": "all protocols"
}


_FLOW_DESC = {
    "activeonly": "active flows only",
    "all": "all flow types"
}


class ProtocolArgDescription(object):
    @staticmethod
    def value_description(value, req_dict, factory):
        return _PROTO_DESC.get(value)


class FlowArgDescription(object):
    @staticmethod
    def value_description(value, req_dict, factory):
        return _FLOW_DESC.get(value)


class GetFlowInfo(CliCommandProvider):
    def __call__(self, cmd_list):
        arg_list = []
        if len(cmd_list) > 4:
            if cmd_list[4] == "tcponly":
                arg_list.extend(["tcp"])
            else:
                arg_list.extend(["all"])
        if len(cmd_list) > 5:
            if cmd_list[5] == "activeonly":
                arg_list.extend(["active"])
            else:
                arg_list.extend(["all"])
        response = get_opsagent_cli_output("get/flows", arg_list)
        output = load_response_output(response)
        if output is None:
            return "MSG_OPSAGENT_EPCT_FAILED"

        status = output.get("status")
        if "ok" in status:
            return "OK\n\n%s" % json.dumps(output)
        else:
            return "MSG_OPSAGENT_EPCT_FAILED"


class GetRuleIds(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_opsagent_cli_output("get/ruleids")
        output = load_response_output(response)
        if output is None:
            return "MSG_OPSAGENT_EPCT_FAILED"

        status = output.get("status")
        if "ok" in status:
            return "OK\n\n%s" % json.dumps(output)
        else:
            return "MSG_OPSAGENT_EPCT_FAILED"
