# **********************************************************************
# Copyright 2015 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import json
import os
import sys

from cli.utils.location_utils import FilePaths


_MPA_ACCOUNT_NAME_KEY = "AccountName"
_MPA_SHARED_SECRET_KEY = "SharedSecret"


def get_mpa_node_config():
    node_uuid = ""
    account_name = ""
    shared_secret   = ""
    if os.path.isfile(FilePaths.MPA_CONFIG_FILE):
        with open(FilePaths.MPA_CONFIG_FILE,"r") as fp:
            mpa_config = json.load(fp)
        account_name = mpa_config[_MPA_ACCOUNT_NAME_KEY]
        shared_secret   = mpa_config[_MPA_SHARED_SECRET_KEY]
    if account_name:
        account_name_split = account_name.split('-')
        if (len(account_name_split) > 5):
            node_uuid = account_name_split[len(account_name_split)-5]
            for i in range(4,0,-1):
                node_uuid += "-" + account_name_split[len(account_name_split)-i]
    return node_uuid, account_name, shared_secret


if __name__ == "__main__":
    if len(sys.argv) > 1 and sys.argv[1] == "node_uuid":
        node_uuid = None
        try:
            node_uuid = get_mpa_node_config()[0]
        except Exception:
            pass  # TODO: log exception
        if node_uuid:
            sys.stdout.write("%s\n" % node_uuid)
        else:
            # For legacy reasons, print the following to stdout if not node_uuid
            sys.stdout.write("% Host is not registered\n")
