# Copyright (C) 2021 VMware, Inc. All rights reserved.
# -- VMware Confidential
from abc import ABCMeta, abstractmethod


class RmdyCmd(metaclass=ABCMeta):
    """
    Base class for remedy cmd. All remedy cmd should implement all the methods here.
    """

    @abstractmethod
    def is_success(self, result):
        raise NotImplementedError('Class RmdyCmd does not implement it.')

    @abstractmethod
    def get_tag_cmd(self):
        raise NotImplementedError('Class RmdyCmd does not implement it.')

    @abstractmethod
    def get_cmd_timeout(self):
        raise NotImplementedError('Class RmdyCmd does not implement it.')

    @abstractmethod
    def get_real_cmd(self):
        raise NotImplementedError('Class RmdyCmd does not implement it.')

